EJ_Settings = {}
EJ_Settings.BarColor = {r = 1, g = 0, b = 1}
EJ_Settings.PartyCallout = false
EJ_Settings.GuildCallout = false
EJ_Settings.CalloutMessage = "DING! Level %s!"
EJ_Settings.ShowDifference = true

local function ChatMessage(text)
    DEFAULT_CHAT_FRAME:AddMessage(text)
end

local ejtex = "Interface\\Addons\\ExpJunkie\\EJ-UI-PartyFrame"
local ptex = "Interface\\TargetingFrame\\UI-PartyFrame"

local Member = {}
Member.__index = Member

function Member:new(pID)
    local self = setmetatable({}, Member)
    self.__index = self
    self.HasEJ = false
    self.PartyID = pID
    self.XPMax = 0
    self.XPCurrent = 0

    self.XPBar = getglobal("PartyMemberFrame" .. pID .. "XPBar")
    self.Tex = getglobal("PartyMemberFrame" .. pID .. "Texture")

    return self
end

local function MoveDebuff(reset)
    if(reset == 1) then
        for pm = 1, 4 do
            for d = 1, 4 do 
                p = getglobal("PartyMemberFrame" .. pm .. "Debuff" .. d)
                p:SetPoint("TOPLEFT", getglobal("PartyMemberFrame"..pm), "TOPLEFT", 48, -31.999996185303)
            end
        end
    else
        for pm = 1, 4 do
            for d = 1, 4 do 
                p = getglobal("PartyMemberFrame" .. pm .. "Debuff" .. d)
                p:SetPoint("TOPLEFT", getglobal("PartyMemberFrame"..pm), "TOPLEFT", 48, -40.5)
            end
        end
    end
end

--[[
    TOPLEFT
    PartyMemberFrame1
    TOPLEFT
    48
    -31.999996185303
]]


local Party = {}

local function RequestParty()
    Party = {}
    if(UnitInRaid("player") == nil) then
        if(GetNumGroupMembers() > 1) then
            for count = 1, GetNumGroupMembers() - 1 do
                local name = UnitName('party' .. count);
                Party[name] = Member:new(count)
                Party[name].Tex:SetTexture(ptex)
                Party[name].XPBar:Hide()
                MoveDebuff(1)
            end
            C_ChatInfo.SendAddonMessage("<EXPJUNKIE>", "request","PARTY")
        end
    else
        for count = 1, 4 do
            xpbar = getglobal("PartyMemberFrame" .. i .. "XPBar")
            tex = getglobal("PartyMemberFrame" .. i .. "Texture")
            tex:SetTexture(ptex)
            xpbar:Hide()
            MoveDebuff(1)
        end
    end
end

local base = CreateFrame("Frame", nil, UIParent)
  
base:RegisterEvent("PLAYER_LOGIN")
base:RegisterEvent("CHAT_MSG_ADDON")
base:RegisterEvent("PLAYER_ENTERING_WORLD")
base:RegisterEvent("GROUP_ROSTER_UPDATE")
base:RegisterEvent("PLAYER_XP_UPDATE")
base:RegisterEvent("PLAYER_LEVEL_UP")
base:RegisterEvent("ADDON_LOADED")


base:SetScript("OnEvent", function (self, event, ...)
    if(event == "ADDON_LOADED") then
        local c = EJ_Settings.BarColor
        for i=1, 4 do
            local x = CreateFrame("StatusBar", "PartyMemberFrame" .. i .. "XPBar", getglobal("PartyMemberFrame" .. i .. "HealthBar"))
            x:SetPoint("TOPLEFT", "PartyMemberFrame" .. i .. "HealthBar", "TOPLEFT", 0, -17)
            x:SetWidth(70)    
            x:SetHeight(7.9999470710754)
            x:SetFrameStrata("BACKGROUND")
            x:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
            x:GetStatusBarTexture():SetHorizTile(false)
            x:GetStatusBarTexture():SetVertTile(false)
            x:SetStatusBarColor(EJ_Settings.BarColor.r,
                                EJ_Settings.BarColor.g, 
                                EJ_Settings.BarColor.b)
            x:Hide()
        
            x:SetMinMaxValues(0,100)
            x:SetValue(0)
        end
    end

    if(event == "PLAYER_LOGIN") then
        ChatMessage("ExpJunkie Loaded.")
        if(C_ChatInfo.IsAddonMessagePrefixRegistered("<EXPJUNKIE>") ~= true) then
            C_ChatInfo.RegisterAddonMessagePrefix("<EXPJUNKIE>")
        end
    end
    if(event=="PLAYER_ENTERING_WORLD") then
        RequestParty()
    end

    if(event == "GROUP_ROSTER_UPDATE") then
        RequestParty()
    end

    if (event == "CHAT_MSG_ADDON") then
        local prefix, message, channel, senderR = ...
        if(prefix == '<EXPJUNKIE>') then
            if(message == "request") then
                local msg = UnitXP('player') .. ',' ..UnitXPMax('player') ..','..MAX_PLAYER_LEVEL
                C_ChatInfo.SendAddonMessage("<EXPJUNKIE>",msg,"PARTY")
            else
                local sender, _ = strsplit("-", senderR)
                if(sender ~= UnitName('player')) then
                    local xpCur, xpMax, MaxLevel = strsplit(",", message)
                    if(Party[sender] == nil) then
                        RequestParty()
                    end
                    local currLevel = UnitLevel('party' .. Party[sender].PartyID)
                    if(tonumber(MaxLevel) == currLevel) then
                        DEFAULT_CHAT_FRAME:AddMessage("EJ: Yes")
                        Party[sender].HasEJ = false
                        Party[sender].Tex:SetTexture(ptex)
                        Party[sender].XPBar:Hide()
                        MoveDebuff(1)
                    else
                        DEFAULT_CHAT_FRAME:AddMessage("EJ: No")
                        Party[sender].HasEJ = true
                        Party[sender].Tex:SetTexture(ejtex)
                        Party[sender].XPBar:Show()
                        MoveDebuff()
                    end
                    Party[sender].XPCurrent = xpCur
                    Party[sender].XPMax = xpMax
                    Party[sender].XPBar:SetValue(xpCur / xpMax * 100)
                end
            end
        end
    end

    if(event == "PLAYER_XP_UPDATE") then
        if(UnitInRaid("player") == nil) then
            local msg = UnitXP('player') .. ',' ..UnitXPMax('player') ..','..MAX_PLAYER_LEVEL
            C_ChatInfo.SendAddonMessage("<EXPJUNKIE>",msg,"PARTY")
        end
    end

    if(event == "PLAYER_LEVEL_UP") then
        ChatMessage("Level up")
        if(GetNumGroupMembers() > 1 and EJ_Settings.PartyCallout == true) then
            SendChatMessage(EJ_Settings.CalloutMessage:format(tostring(UnitLevel('player')+1)),"Party")
        end
        if(IsInGuild() and EJ_Settings.GuildCallout == true) then
            SendChatMessage(EJ_Settings.CalloutMessage:format(tostring(UnitLevel('player')+1)),"Guild")
        end
    end
end)


-----------------------------
-- Tooltip Hooking         --
-----------------------------

local gtt = GameTooltip

gtt:HookScript("OnTooltipSetUnit", function(self)
    if(GetNumGroupMembers() > 0) then
        for p=1,4 do
            local unit = UnitName("party"..p)
            if(Party[UnitName("party"..p)] ~= nil) then
                local member = Party[UnitName("party"..p)]
    		    if (self:GetUnit() == unit and member.HasEJ == true) then
			        local percentXP = math.ceil(member.XPCurrent/member.XPMax*100)
			        self:AddLine(" ")
                    self:AddDoubleLine("Experience:",member.XPCurrent .. "/" .. member.XPMax .. " ( " .. percentXP .. "% )",1,1,1,0,1,0)
                    if(EJ_Settings.ShowDifference == true and UnitLevel("player") == UnitLevel("party"..p)) then
                        if(UnitXP("player") > tonumber(member.XPCurrent)) then
                            self:AddLine("You are ahead by " .. UnitXP("player") - tonumber(member.XPCurrent))
                        else
                            self:AddLine("You are behind by " .. tonumber(member.XPCurrent) - UnitXP("player"))
                        end
                    end
                end
            end
         end
    end
end)

-----------------------
-- Interface Options --
-----------------------

local frame = CreateFrame("Frame", "EJC_ConfigFrame", InterfaceOptionsFramePanelContainer)
frame.name = "ExpJunkie"
frame:Hide()

frame:SetScript("OnShow", function(frame)
    local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
    title:SetPoint("TOPLEFT", 16, -16)
    title:SetText("Experience Junkie")

    local subtitle = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
    subtitle:SetHeight(35)
    subtitle:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
    subtitle:SetPoint("RIGHT", frame, -32, 0)
    subtitle:SetNonSpaceWrap(true)
    subtitle:SetJustifyH("LEFT")
    subtitle:SetJustifyV("TOP")
    subtitle:SetText("This panel can be used to configure ExpJunkie.")

    --Sliders for color selection
    local r_slider = CreateFrame("Slider", "EJC_ConfigBarRed", frame, "OptionsSliderTemplate")
    r_slider:SetPoint("TOPLEFT", subtitle, "BOTTOMLEFT",20, -15)
    r_slider:SetMinMaxValues(0,100)
    r_slider:SetValueStep(1)
    r_slider.text = _G[r_slider:GetName() .. "Text"]
    r_slider.low = _G[r_slider:GetName() .. "Low"]
    r_slider.high = _G[r_slider:GetName() .. "High"]
    r_slider.text:SetText("ExpJunkie party bar colors")
    r_slider.low:SetText("Red")
    r_slider.high:SetText("")
    r_slider.tooltipText = "Change the color of the bar."

    r_slider:SetScript("OnValueChanged", function(self, value)
        for i=1, 4 do
            local bar = getglobal("PartyMemberFrame" .. i .. "XPBar")
            EJ_Settings.BarColor.r = (value / 100)
            bar:SetStatusBarColor(EJ_Settings.BarColor.r,
                                  EJ_Settings.BarColor.g,
                                  EJ_Settings.BarColor.b)
        end
    end)

    local g_slider = CreateFrame("Slider", "EJC_ConfigBarGreen", frame, "OptionsSliderTemplate")
    g_slider:SetPoint("TOPLEFT", r_slider, "BOTTOMLEFT",0, -25)
    g_slider:SetMinMaxValues(0,100)
    g_slider:SetValueStep(1)
    g_slider.text = _G[g_slider:GetName() .. "Text"]
    g_slider.low = _G[g_slider:GetName() .. "Low"]
    g_slider.high = _G[g_slider:GetName() .. "High"]
    g_slider.text:SetText("")
    g_slider.low:SetText("Green")
    g_slider.high:SetText("")
    g_slider.tooltipText = "Change the color of the bar."

    g_slider:SetScript("OnValueChanged", function(self, value)
        for i=1, 4 do
            local bar = getglobal("PartyMemberFrame" .. i .. "XPBar")
            EJ_Settings.BarColor.g = (value / 100)
            bar:SetStatusBarColor(EJ_Settings.BarColor.r,
                                  EJ_Settings.BarColor.g,
                                  EJ_Settings.BarColor.b)
        end
    end)

    local b_slider = CreateFrame("Slider", "EJC_ConfigBarBlue", frame, "OptionsSliderTemplate")
    b_slider:SetPoint("TOPLEFT", g_slider, "BOTTOMLEFT",0, -25)
    b_slider:SetMinMaxValues(0,100)
    b_slider:SetValueStep(1)
    b_slider.text = _G[b_slider:GetName() .. "Text"]
    b_slider.low = _G[b_slider:GetName() .. "Low"]
    b_slider.high = _G[b_slider:GetName() .. "High"]
    b_slider.text:SetText("")
    b_slider.low:SetText("Blue")
    b_slider.high:SetText("")
    b_slider.tooltipText = "Change the color of the bar."

    b_slider:SetScript("OnValueChanged", function(self, value)
        for i=1, 4 do
            local bar = getglobal("PartyMemberFrame" .. i .. "XPBar")
            EJ_Settings.BarColor.b = (value / 100)
            bar:SetStatusBarColor(EJ_Settings.BarColor.r,
                                  EJ_Settings.BarColor.g,
                                  EJ_Settings.BarColor.b)
        end
    end)

    --Checkboxes for Level Up Callout
    local calloutTitle = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
    calloutTitle:SetHeight(20)
    calloutTitle:SetPoint("TOPLEFT", b_slider, "BOTTOMLEFT", 0, -45)
    calloutTitle:SetPoint("RIGHT", frame, -32, 0)
    calloutTitle:SetNonSpaceWrap(true)
    calloutTitle:SetJustifyH("LEFT")
    calloutTitle:SetJustifyV("TOP")
    calloutTitle:SetText("Settings for the automatic callout when leveling up")

    local p_check = CreateFrame("CheckButton", "EJC_ConfigPartyCallout", frame, "ChatConfigCheckButtonTemplate")
    p_check:SetPoint("TOPLEFT", calloutTitle, "BOTTOMLEFT", 0, 0)
    p_check.text = _G[p_check:GetName() .. "Text"]
    p_check.text:SetText("Auto Level up party Callout")

    p_check:SetScript("OnClick", function() 
        if(EJ_Settings.PartyCallout == false) then
            EJ_Settings.PartyCallout = true
        else
            EJ_Settings.PartyCallout = false
        end
    end)

    local g_check = CreateFrame("CheckButton", "EJC_ConfigGuildCallout", frame, "ChatConfigCheckButtonTemplate")
    g_check:SetPoint("TOPLEFT", p_check, "BOTTOMLEFT", 0, -10)
    g_check.text = _G[g_check:GetName() .. "Text"]
    g_check.text:SetText("Auto Level up guild Callout")

    g_check:SetScript("OnClick", function() 
        if(EJ_Settings.GuildCallout == false) then
            EJ_Settings.GuildCallout = true
        else
            EJ_Settings.GuildCallout = false
        end
    end)
    
    local callout = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
    callout:SetHeight(20)
    callout:SetPoint("TOPLEFT", g_check, "BOTTOMLEFT", 0, -8)
    callout:SetPoint("RIGHT", frame, -32, 0)
    callout:SetNonSpaceWrap(true)
    callout:SetJustifyH("LEFT")
    callout:SetJustifyV("TOP")
    callout:SetText("Automatic callout message when leveling up. (the '%s' is your current level)")

    calloutMsg = CreateFrame("EditBox", "EJC_ConfigCalloutMessage", frame, "InputBoxTemplate")
    calloutMsg:SetPoint("TOPLEFT", callout, "BOTTOMLEFT", 0, -5)
    calloutMsg:SetHeight(30)
    calloutMsg:SetWidth(300)
    calloutMsg:SetMultiLine(false)
    calloutMsg:SetMaxLetters(500)
    calloutMsg:SetFontObject(GameFontNormal)
    calloutMsg:SetAutoFocus(false)
    

    calloutMsg:SetScript("OnKeyUp", function(self, key)
        EJ_Settings.CalloutMessage = calloutMsg:GetText()
    end)

    local Refresh;
    function Refresh()
        if not frame:IsVisible() then return end
        r_slider:SetValue(EJ_Settings.BarColor.r * 100)
        g_slider:SetValue(EJ_Settings.BarColor.g * 100)
        b_slider:SetValue(EJ_Settings.BarColor.b * 100)
        p_check:SetChecked(EJ_Settings.PartyCallout)
        g_check:SetChecked(EJ_Settings.GuildCallout)
        calloutMsg:SetText(EJ_Settings.CalloutMessage)
    end

    frame:SetScript("OnShow", Refresh)
    Refresh()
end)
   




InterfaceOptions_AddCategory(frame)